#ifndef ADIF_H
#define ADIF_H
#include "appglobal.h"

#include <QStringList>
#include <QFile>
#include <QTextStream>

#define NUMBEROFQSOFIELDS 107

enum eparse {EOH,EOR};

struct sQSO
{
  QString tag;
  QString *value;
  void clear()
  {
    value->clear();
  }
};

class adif
{
public:
  adif();
  ~adif();
  QStringList getFieldList(bool tagged);
  eerrorType openFile();
  bool readRecord();
  QString getValue(QString tag);
private:
  QString iofn;
  QFile iofile;
  QTextStream *ts;
  QString errorString;
  QString s;
  bool split(QString &fieldsLeft);
  bool parse(QString &record);
  bool setValue(QString tag);
  int recordLine;
  QString tag;
  QString value;
  eparse parseState;
};

#endif // ADIF_H
