#ifndef TEMPLATEFORM_H
#define TEMPLATEFORM_H
#include <adif.h>

#include <QWidget>
#include <QComboBox>
#include <QGridLayout>
#include <QSpinBox>
#include <QLineEdit>
#include <QPlainTextEdit>
#include <QFileInfoList>
#include "headerinfoform.h"

#include <QSettings>

#define MAXFIELDS 18


struct stemplate
{
  QComboBox *cbPtr;
  QSpinBox  *lengthPtr;
  QLineEdit *parsePtr;
};


class templateForm : public QWidget
{
  Q_OBJECT

public:
  explicit templateForm(QWidget *parent = 0);
  ~templateForm();
  void process(headerInfoForm *headerPtr,  QPlainTextEdit *textWindowPtr);
  void save(QPlainTextEdit *textWindowPtr);
  void writeSettings();
    void readSettings();
private slots:
      eerrorType saveTemplate();
      void slotTemplateChange(int idx);

private:
  void setup();
  void setupFields();
  eerrorType loadTemplate(QString iofn, QString name);


  QComboBox *templateComboBox;
  QLineEdit *sortLineEdit;
  QGridLayout *gridLayout ;
  stemplate templateFieldArray[MAXFIELDS];
  QPlainTextEdit *notesPlainText;
  adif adf;
  QString templateFile;
  QString iofn;
  QFileInfoList templateFiles;
  QString getEntry(QSettings *qs, QString param, int idx);
  void setEntry(QSettings *qs,QString param,int idx,QString value);
  void appendFields(int idx);
  QString parse(QString pStr, QString src, int length);

  QStringList qsoStrList;
  QList<QStringList> qsoList;
  void sorting();
};

#endif // TEMPLATEFORM_H
